import { TNSWebGLRenderingContext } from './TNSWebGLRenderingContext';
import { WebGLBuffer, WebGLProgram, WebGLQuery, WebGLSampler, WebGLSync, WebGLTexture, WebGLTransformFeedback, WebGLUniformLocation, WebGLVertexArrayObject } from './canvas-plugin.common';
export declare class TNSWebGL2RenderingContext extends TNSWebGLRenderingContext {
    constructor(context: any);
    readonly ALREADY_SIGNALED: number;
    readonly ANY_SAMPLES_PASSED: number;
    readonly ANY_SAMPLES_PASSED_CONSERVATIVE: number;
    readonly BYTE: number;
    readonly COLOR: number;
    readonly COLOR_ATTACHMENT1: number;
    readonly COLOR_ATTACHMENT10: number;
    readonly COLOR_ATTACHMENT11: number;
    readonly COLOR_ATTACHMENT12: number;
    readonly COLOR_ATTACHMENT13: number;
    readonly COLOR_ATTACHMENT14: number;
    readonly COLOR_ATTACHMENT15: number;
    readonly COLOR_ATTACHMENT2: number;
    readonly COLOR_ATTACHMENT3: number;
    readonly COLOR_ATTACHMENT4: number;
    readonly COLOR_ATTACHMENT5: number;
    readonly COLOR_ATTACHMENT6: number;
    readonly COLOR_ATTACHMENT7: number;
    readonly COLOR_ATTACHMENT8: number;
    readonly COLOR_ATTACHMENT9: number;
    readonly CONDITION_SATISFIED: number;
    readonly COPY_READ_BUFFER: number;
    readonly COPY_WRITE_BUFFER: number;
    readonly CURRENT_QUERY: number;
    readonly DEPTH: number;
    readonly DEPTH24_STENCIL8: number;
    readonly DEPTH32F_STENCIL8: number;
    readonly DEPTH_COMPONENT24: number;
    readonly DEPTH_COMPONENT32F: number;
    readonly DRAW_FRAMEBUFFER: number;
    readonly FLOAT_32_UNSIGNED_INT_24_8_REV: number;
    readonly QUERY_COUNTER_BITS: number;
    readonly QUERY_COUNTER_BITS_EXT: number;
    readonly HALF_FLOAT: number;
    readonly INTERLEAVED_ATTRIBS: number;
    readonly MAX_CLIENT_WAIT_TIMEOUT_WEBGL: number;
    readonly NONE: number;
    readonly OBJECT_TYPE: number;
    readonly PIXEL_PACK_BUFFER: number;
    readonly PIXEL_UNPACK_BUFFER: number;
    readonly QUERY_RESULT: number;
    readonly QUERY_RESULT_AVAILABLE: number;
    readonly R11F_G11F_B10F: number;
    readonly R16F: number;
    readonly R16I: number;
    readonly R16UI: number;
    readonly R32F: number;
    readonly R32I: number;
    readonly R32UI: number;
    readonly R8: number;
    readonly R8G: number;
    readonly R8I: number;
    readonly R8UI: number;
    readonly READ_FRAMEBUFFER: number;
    readonly RG16F: number;
    readonly RG16I: number;
    readonly RG16UI: number;
    readonly RG32F: number;
    readonly RG32I: number;
    readonly RG32UI: number;
    readonly RG8I: number;
    readonly RG8UI: number;
    readonly RGB10_A2: number;
    readonly RGB10_A2UI: number;
    readonly RGB16F: number;
    readonly RGB32F: number;
    readonly RGB8: number;
    readonly RGB8UI: number;
    readonly RGB9_E5: number;
    readonly RGBA16F: number;
    readonly RGBA16I: number;
    readonly RGBA16UI: number;
    readonly RGBA32F: number;
    readonly RGBA32I: number;
    readonly RGBA32UI: number;
    readonly RGBA4444: number;
    readonly RGBA8: number;
    readonly RGBA8I: number;
    readonly RGBA8UI: number;
    readonly SEPARATE_ATTRIBS: number;
    readonly SHORT: number;
    readonly SIGNALED: number;
    readonly SRGB8: number;
    readonly SRGB8_ALPHA8: number;
    readonly SRGB_APLHA8: number;
    readonly STENCIL: number;
    readonly SYNC_CONDITION: number;
    readonly SYNC_FENCE: number;
    readonly SYNC_FLAGS: number;
    readonly SYNC_FLUSH_COMMANDS_BIT: number;
    readonly SYNC_GPU_COMMANDS_COMPLETE: number;
    readonly SYNC_STATUS: number;
    readonly TEXTURE_2D_ARRAY: number;
    readonly TEXTURE_3D: number;
    readonly TEXTURE_COMPARE_FUNC: number;
    readonly TEXTURE_COMPARE_MODE: number;
    readonly TEXTURE_MAX_LOD: number;
    readonly TEXTURE_MIN_LOD: number;
    readonly TEXTURE_WRAP_R: number;
    readonly TIMEOUT_EXPIRED: number;
    readonly TRANSFORM_FEEDBACK_BUFFER: number;
    readonly TRANSFORM_FEEDBACK_BUFFER_BINDING: number;
    readonly TRANSFORM_FEEDBACK_BUFFER_SIZE: number;
    readonly TRANSFORM_FEEDBACK_BUFFER_START: number;
    readonly TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN: number;
    readonly UNIFORM_ARRAY_STRIDE: number;
    readonly UNIFORM_BLOCK_ACTIVE_UNIFORMS: number;
    readonly UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES: number;
    readonly UNIFORM_BLOCK_BINDING: number;
    readonly UNIFORM_BLOCK_DATA_SIZE: number;
    readonly UNIFORM_BLOCK_INDEX: number;
    readonly UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER: number;
    readonly UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER: number;
    readonly UNIFORM_BUFFER: number;
    readonly UNIFORM_BUFFER_BINDING: number;
    readonly UNIFORM_BUFFER_SIZE: number;
    readonly UNIFORM_BUFFER_START: number;
    readonly UNIFORM_IS_ROW_MAJOR: number;
    readonly UNIFORM_MATRIX_STRIDE: number;
    readonly UNIFORM_OFFSET: number;
    readonly UNIFORM_SIZE: number;
    readonly UNIFORM_TYPE: number;
    readonly UNSIGNALED: number;
    readonly UNSIGNED_INT_10F_11F_11F_REV: number;
    readonly UNSIGNED_INT_24_8: number;
    readonly UNSIGNED_INT_2_10_10_10_REV: number;
    readonly UNSIGNED_INT_5_9_9_9_REV: number;
    readonly WAIT_FAILED: number;
    static isDebug: boolean;
    protected _glCheckError(message: string): void;
    beginQuery(target: number, query: WebGLQuery): void;
    beginTransformFeedback(primitiveMode: number): void;
    bindBufferBase(target: number, index: number, buffer: WebGLBuffer): void;
    bindBufferRange(target: number, index: number, buffer: WebGLBuffer, offset: number, size: number): void;
    bindSampler(unit: number, sampler: WebGLSampler): void;
    bindTransformFeedback(target: number, transformFeedback: WebGLTransformFeedback): void;
    bindVertexArray(vertexArray: WebGLVertexArrayObject): void;
    blitFramebuffer(srcX0: number, srcY0: number, srcX1: number, srcY1: number, dstX0: number, dstY0: number, dstX1: number, dstY1: number, mask: number, filter: number): void;
    clearBufferfi(buffer: WebGLBuffer, drawbuffer: number, depth: number, stencil: number): void;
    clearBufferfv(buffer: WebGLBuffer, drawbuffer: number, values: number[] | Float32Array): void;
    clearBufferiv(buffer: WebGLBuffer, drawbuffer: number, values: number[] | Int32Array): void;
    clearBufferuiv(buffer: WebGLBuffer, drawbuffer: number, values: number[] | Uint32Array): void;
    clientWaitSync(sync: WebGLSync, flags: number, timeout: number): number;
    compressedTexSubImage3D(target: number, level: number, xoffset: number, yoffset: number, zoffset: number, width: number, height: number, depth: number, format: number, imageSize: number, offset: any): any;
    copyBufferSubData(readTarget: number, writeTarget: number, readOffset: number, writeOffset: number, size: number): void;
    copyTexSubImage3D(target: number, level: number, xoffset: number, yoffset: number, zoffset: number, x: number, y: number, width: number, height: number): void;
    createQuery(): WebGLQuery;
    createSampler(): WebGLSampler;
    createTransformFeedback(): WebGLTransformFeedback;
    createVertexArray(): WebGLVertexArrayObject;
    deleteQueryWithQuery(query: WebGLQuery): void;
    deleteSamplerWithSampler(sampler: WebGLSampler): void;
    deleteSyncWithSync(sync: WebGLSync): void;
    deleteTransformFeedback(transformFeedback: WebGLTransformFeedback): void;
    deleteVertexArray(vertexArray: WebGLVertexArrayObject): void;
    drawArraysInstanced(mode: number, first: number, count: number, instanceCount: number): void;
    drawBuffers(buffers: number[]): void;
    drawElementsInstanced(mode: number, count: number, type: number, offset: number, instanceCount: number): void;
    drawRangeElements(mode: number, start: number, end: number, count: number, type: number, offset: number): void;
    endQuery(target: number): void;
    endTransformFeedback(): void;
    fenceSync(condition: number, flags: number): void;
    framebufferTextureLayer(target: number, attachment: number, texture: WebGLTexture, level: number, layer: number): void;
    getActiveUniformBlockName(program: WebGLProgram, uniformBlockIndex: number): string;
    getActiveUniformBlockParameter(program: WebGLProgram, uniformBlockIndex: number, pname: number): any;
    getActiveUniforms(program: WebGLProgram, uniformIndices: number[], pname: number): any;
    getBufferSubData(target: number, srcByteOffset: number, dstData: ArrayBuffer, dstOffset?: number, length?: number): void;
    getFragDataLocation(program: WebGLProgram, name: string): number;
    getIndexedParameter(target: number, index: number): any;
    getInternalformatParameter(target: number, internalformat: number, pname: number): any;
    getQueryParameter(query: WebGLQuery, pname: number): any;
    getQuery(target: number, pname: number): any;
    getSamplerParameter(sampler: WebGLSampler, pname: number): any;
    getSyncParameter(sync: WebGLSync, pname: number): any;
    getTransformFeedbackVarying(program: WebGLProgram, index: number): any;
    getUniformBlockIndex(program: WebGLProgram, uniformBlockName: string): number;
    getUniformIndices(program: WebGLProgram, uniformNames: string[]): number[];
    invalidateFramebuffer(target: number, attachments: number[]): void;
    invalidateSubFramebuffer(target: number, attachments: number[], x: number, y: number, width: number, height: number): void;
    isQuery(query: WebGLQuery): boolean;
    isSampler(sampler: WebGLSampler): boolean;
    isSync(sync: WebGLSync): boolean;
    isTransformFeedback(transformFeedback: WebGLTransformFeedback): boolean;
    isVertexArray(vertexArray: WebGLVertexArrayObject): boolean;
    pauseTransformFeedback(): void;
    readBuffer(src: number): void;
    renderbufferStorageMultisample(target: number, samples: number, internalFormat: number, width: number, height: number): void;
    resumeTransformFeedback(): void;
    samplerParameterf(sampler: WebGLSampler, pname: number, param: number): void;
    samplerParameteri(sampler: WebGLSampler, pname: number, param: number): void;
    texImage3D(target: number, level: number, internalformat: number, width: number, height: number, depth: number, border: number, format: number, type: number, offset: any): any;
    texStorage2D(target: number, levels: number, internalformat: number, width: number, height: number): void;
    texStorage3D(target: number, levels: number, internalformat: number, width: number, height: number, depth: number): void;
    texSubImage3D(target: number, level: number, xoffset: number, yoffset: number, zoffset: number, width: number, height: number, depth: number, format: number, type: number, offset: any): any;
    texSubImage3D(target: number, level: number, xoffset: number, yoffset: number, zoffset: number, width: number, height: number, depth: number, format: number, type: number, srcData: any): any;
    transformFeedbackVaryings(program: WebGLProgram, varyings: string[], bufferMode: number): void;
    uniform1ui(location: number, v0: number): void;
    uniform1uiv(location: number, data: Uint32Array): void;
    uniform2ui(location: number, v0: number, v1: number): void;
    uniform2uiv(location: number, data: Uint32Array): void;
    uniform3ui(location: number, v0: number, v1: number, v2: number): void;
    uniform3uiv(location: number, data: Uint32Array): void;
    uniform4ui(location: number, v0: number, v1: number, v2: number, v3: number): void;
    uniform4uiv(location: number, data: Uint32Array): void;
    uniformBlockBinding(program: WebGLProgram, uniformBlockIndex: number, uniformBlockBinding: number): void;
    uniformMatrix2x3fv(location: WebGLUniformLocation, transpose: boolean, data: Float32Array): void;
    uniformMatrix2x4fv(location: WebGLUniformLocation, transpose: boolean, data: Float32Array): void;
    uniformMatrix3x2fv(location: WebGLUniformLocation, transpose: boolean, data: Float32Array): void;
    uniformMatrix3x4fv(location: WebGLUniformLocation, transpose: boolean, data: Float32Array): void;
    uniformMatrix4x2fv(location: WebGLUniformLocation, transpose: boolean, data: Float32Array): void;
    uniformMatrix4x3fv(location: WebGLUniformLocation, transpose: boolean, data: Float32Array): void;
    vertexAttribDivisor(index: number, divisor: number): void;
    vertexAttribI4i(index: number, v0: number, v1: number, v2: number, v3: number): void;
    vertexAttribI4iv(index: number, value: number[] | Int32Array): void;
    vertexAttribI4ui(index: number, v0: number, v1: number, v2: number, v3: number): void;
    vertexAttribI4uiv(index: number, value: number[] | Uint32Array): void;
}
