"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var view_1 = require("tns-core-modules/ui/core/view");
var gestures_1 = require("tns-core-modules/ui/gestures/gestures");
var platform_1 = require("tns-core-modules/platform");
__export(require("tns-core-modules/ui/core/view"));
var TNSCanvasBase = (function (_super) {
    __extends(TNSCanvasBase, _super);
    function TNSCanvasBase() {
        var _this = _super.call(this) || this;
        _this._touchEvents = _this._touchEventsFN.bind(_this);
        _this.on('touch, pan', _this._touchEvents);
        return _this;
    }
    TNSCanvasBase.prototype._emitEvent = function (name, event) {
        this.notify(this._getTouchEvent(name, event, this));
    };
    TNSCanvasBase.prototype._touchEventsFN = function (event) {
        if (event.eventName === 'touch') {
            switch (event.action) {
                case 'down':
                    this._emitEvent('touchstart', event);
                    break;
                case 'up':
                    this._emitEvent('touchend', event);
                    break;
                case 'cancel':
                    this._emitEvent('touchcancel', event);
                    break;
                case 'move':
                    break;
                default:
                    break;
            }
        }
        else if (event.eventName === 'pan') {
            if (event.state === gestures_1.GestureStateTypes.began || event.state === gestures_1.GestureStateTypes.changed) {
                this._emitEvent('touchmove', event);
            }
        }
    };
    TNSCanvasBase.prototype._getTouchEvent = function (name, event, target) {
        var pointers = new TouchList();
        var scale = platform_1.screen.mainScreen.scale;
        var activePointer = {};
        if (name === 'touchmove') {
            activePointer = {
                clientX: event.deltaX * scale,
                clientY: event.deltaY * scale,
                force: 0.0,
                identifier: 0,
                pageX: event.deltaX * scale,
                pageY: event.deltaY * scale,
                radiusX: 0,
                radiusY: 0,
                rotationAngle: 0,
                screenX: event.deltaX * scale,
                screenY: event.deltaY * scale,
                target: target,
            };
            pointers.push({
                clientX: event.deltaX * scale,
                clientY: event.deltaY * scale,
                force: 0.0,
                identifier: 0,
                pageX: event.deltaX * scale,
                pageY: event.deltaY * scale,
                radiusX: 0,
                radiusY: 0,
                rotationAngle: 0,
                screenX: event.deltaX * scale,
                screenY: event.deltaY * scale,
                target: target,
            });
        }
        else {
            var count = event.getAllPointers().length;
            var point = event.getActivePointers()[0];
            activePointer = {
                clientX: point.getX() * scale,
                clientY: point.getY() * scale,
                force: 0.0,
                identifier: 0,
                pageX: point.getX() * scale,
                pageY: point.getY() * scale,
                radiusX: 0,
                radiusY: 0,
                rotationAngle: 0,
                screenX: point.getX() * scale,
                screenY: point.getY() * scale,
            };
            for (var i = 0; i < count; i++) {
                var point_1 = event.getAllPointers()[i];
                pointers.push({
                    clientX: point_1.getX(),
                    clientY: point_1.getY(),
                    force: 0.0,
                    identifier: i,
                    pageX: point_1.getX(),
                    pageY: point_1.getY(),
                    radiusX: 0,
                    radiusY: 0,
                    rotationAngle: 0,
                    screenX: point_1.getX(),
                    screenY: point_1.getY(),
                    target: target,
                });
            }
        }
        return __assign({ eventName: name, object: null, defaultPrevented: false, cancelable: false, altKey: false, changedTouches: pointers, ctrlKey: false, metaKey: false, shiftKey: false, targetTouches: pointers, touches: pointers, preventDefault: function () {
            }, target: target }, activePointer);
    };
    TNSCanvasBase = __decorate([
        view_1.CSSType('TNSCanvas'),
        __metadata("design:paramtypes", [])
    ], TNSCanvasBase);
    return TNSCanvasBase;
}(view_1.ContainerView));
exports.TNSCanvasBase = TNSCanvasBase;
var TouchList = (function (_super) {
    __extends(TouchList, _super);
    function TouchList() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TouchList.prototype.item = function (index) {
        return this[index];
    };
    return TouchList;
}(Array));
var TNSImageAssetBase = (function () {
    function TNSImageAssetBase(nativeInstance) {
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(TNSImageAssetBase.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    return TNSImageAssetBase;
}());
exports.TNSImageAssetBase = TNSImageAssetBase;
var TNSImageAssetSaveFormat;
(function (TNSImageAssetSaveFormat) {
    TNSImageAssetSaveFormat[TNSImageAssetSaveFormat["JPG"] = 0] = "JPG";
    TNSImageAssetSaveFormat[TNSImageAssetSaveFormat["PNG"] = 1] = "PNG";
    TNSImageAssetSaveFormat[TNSImageAssetSaveFormat["ICO"] = 2] = "ICO";
    TNSImageAssetSaveFormat[TNSImageAssetSaveFormat["BMP"] = 3] = "BMP";
    TNSImageAssetSaveFormat[TNSImageAssetSaveFormat["TIFF"] = 4] = "TIFF";
})(TNSImageAssetSaveFormat = exports.TNSImageAssetSaveFormat || (exports.TNSImageAssetSaveFormat = {}));
var TNSCanvasRenderingContext2DBase = (function () {
    function TNSCanvasRenderingContext2DBase() {
        this._type = 'none';
    }
    Object.defineProperty(TNSCanvasRenderingContext2DBase.prototype, "canvas", {
        get: function () {
            return this._canvas;
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(TNSCanvasRenderingContext2DBase.prototype, "type", {
        get: function () {
            return this._type;
        },
        enumerable: true,
        configurable: true
    });
    return TNSCanvasRenderingContext2DBase;
}());
exports.TNSCanvasRenderingContext2DBase = TNSCanvasRenderingContext2DBase;
var WebGLProgram = (function () {
    function WebGLProgram(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLProgram';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLProgram.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLProgram.prototype.toString = function () {
        return '[object WebGLProgram]';
    };
    return WebGLProgram;
}());
exports.WebGLProgram = WebGLProgram;
var WebGLShader = (function () {
    function WebGLShader(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLShader';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLShader.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLShader.prototype.toString = function () {
        return '[object WebGLShader]';
    };
    return WebGLShader;
}());
exports.WebGLShader = WebGLShader;
var WebGLBuffer = (function () {
    function WebGLBuffer(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLBuffer';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLBuffer.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLBuffer.prototype.toString = function () {
        return '[object WebGLBuffer]';
    };
    return WebGLBuffer;
}());
exports.WebGLBuffer = WebGLBuffer;
var WebGLFramebuffer = (function () {
    function WebGLFramebuffer(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLFramebuffer';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLFramebuffer.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLFramebuffer.prototype.toString = function () {
        return '[object WebGLFramebuffer]';
    };
    return WebGLFramebuffer;
}());
exports.WebGLFramebuffer = WebGLFramebuffer;
var WebGLRenderbuffer = (function () {
    function WebGLRenderbuffer(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLRenderbuffer';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLRenderbuffer.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLRenderbuffer.prototype.toString = function () {
        return '[object WebGLRenderbuffer]';
    };
    return WebGLRenderbuffer;
}());
exports.WebGLRenderbuffer = WebGLRenderbuffer;
var WebGLTexture = (function () {
    function WebGLTexture(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLTexture';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLTexture.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLTexture.prototype.toString = function () {
        return '[object WebGLTexture]';
    };
    return WebGLTexture;
}());
exports.WebGLTexture = WebGLTexture;
var WebGLActiveInfo = (function () {
    function WebGLActiveInfo(name, size, type) {
        this[Symbol.toStringTag] = 'WebGLActiveInfo';
        this.name = name;
        this.size = size;
        this.type = type;
    }
    WebGLActiveInfo.prototype.toString = function () {
        return '[object WebGLActiveInfo]';
    };
    return WebGLActiveInfo;
}());
exports.WebGLActiveInfo = WebGLActiveInfo;
var WebGLShaderPrecisionFormat = (function () {
    function WebGLShaderPrecisionFormat(rangeMin, rangeMax, precision) {
        this[Symbol.toStringTag] = 'WebGLShaderPrecisionFormat';
        this.rangeMin = rangeMin;
        this.rangeMax = rangeMax;
        this.precision = precision;
    }
    WebGLShaderPrecisionFormat.prototype.toString = function () {
        return '[object WebGLShaderPrecisionFormat]';
    };
    return WebGLShaderPrecisionFormat;
}());
exports.WebGLShaderPrecisionFormat = WebGLShaderPrecisionFormat;
var WebGLUniformLocation = (function () {
    function WebGLUniformLocation(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLUniformLocation';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLUniformLocation.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLUniformLocation.prototype.toString = function () {
        return '[object WebGLUniformLocation]';
    };
    return WebGLUniformLocation;
}());
exports.WebGLUniformLocation = WebGLUniformLocation;
var TNSWebGLRenderingContextBase = (function () {
    function TNSWebGLRenderingContextBase() {
        this._type = 'none';
    }
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "canvas", {
        get: function () {
            return this._canvas;
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "type", {
        get: function () {
            return this._type;
        },
        enumerable: true,
        configurable: true
    });
    return TNSWebGLRenderingContextBase;
}());
exports.TNSWebGLRenderingContextBase = TNSWebGLRenderingContextBase;
var TNSPath2DBase = (function () {
    function TNSPath2DBase(instance) {
        this.nativeInstance = instance;
    }
    Object.defineProperty(TNSPath2DBase.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    return TNSPath2DBase;
}());
exports.TNSPath2DBase = TNSPath2DBase;
var TNSDOMMatrixBase = (function () {
    function TNSDOMMatrixBase(nativeInstance) {
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(TNSDOMMatrixBase.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    return TNSDOMMatrixBase;
}());
exports.TNSDOMMatrixBase = TNSDOMMatrixBase;
var ImageDataBase = (function () {
    function ImageDataBase(nativeInstance) {
        this.width = 0;
        this.height = 0;
        this.data = null;
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(ImageDataBase.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    return ImageDataBase;
}());
exports.ImageDataBase = ImageDataBase;
var CanvasGradientBase = (function () {
    function CanvasGradientBase() {
    }
    return CanvasGradientBase;
}());
exports.CanvasGradientBase = CanvasGradientBase;
var CanvasPattern = (function () {
    function CanvasPattern() {
    }
    return CanvasPattern;
}());
exports.CanvasPattern = CanvasPattern;
var TextMetricsBase = (function () {
    function TextMetricsBase(nativeInstance) {
        this.nativeInstance = nativeInstance;
    }
    return TextMetricsBase;
}());
exports.TextMetricsBase = TextMetricsBase;
var WebGLQuery = (function () {
    function WebGLQuery(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLQuery';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLQuery.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLQuery.prototype.toString = function () {
        return '[object WebGLQuery]';
    };
    return WebGLQuery;
}());
exports.WebGLQuery = WebGLQuery;
var WebGLSampler = (function () {
    function WebGLSampler(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLSampler';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLSampler.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLSampler.prototype.toString = function () {
        return '[object WebGLSampler]';
    };
    return WebGLSampler;
}());
exports.WebGLSampler = WebGLSampler;
var WebGLTransformFeedback = (function () {
    function WebGLTransformFeedback(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLTransformFeedback';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLTransformFeedback.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLTransformFeedback.prototype.toString = function () {
        return '[object WebGLTransformFeedback]';
    };
    return WebGLTransformFeedback;
}());
exports.WebGLTransformFeedback = WebGLTransformFeedback;
var WebGLVertexArrayObject = (function () {
    function WebGLVertexArrayObject(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLVertexArrayObject';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLVertexArrayObject.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLVertexArrayObject.prototype.toString = function () {
        return '[object WebGLVertexArrayObject]';
    };
    return WebGLVertexArrayObject;
}());
exports.WebGLVertexArrayObject = WebGLVertexArrayObject;
var WebGLSync = (function () {
    function WebGLSync(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLSync';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLSync.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLSync.prototype.toString = function () {
        return '[object WebGLSync]';
    };
    return WebGLSync;
}());
exports.WebGLSync = WebGLSync;
//# sourceMappingURL=canvas-plugin.common.js.map